#==============================================================================
# ■ GL_Dungeon
#------------------------------------------------------------------------------
# 　3Dダンション画面のOpenGLによる描画を行うクラスです。
#==============================================================================

class GL_Dungeon
  CHIP_SIZE = 32
  include OpenGL32, Glu32
  def initialize(tile_bmp = RPG::Cache.tileset("mapchip02"))
    @map_data = $game_map.data
    @tex = GL_Texture.new(tile_bmp)
  end
  def refresh_map_list
    if @list
      glDeleteLists(@list)
    end
    @list = glGenLists
    glNewList(@list, GL_COMPILE)
    @tex.enable do
      15.times do |z|
        20.times do |x|
          glPushMatrix
          glTranslatef(200 * x, 0, -200 * z)
          t = @map_data[x, z, 0] - 384
          @tex.set_rect(t * (CHIP_SIZE + 1), 0, CHIP_SIZE, CHIP_SIZE)
          case t
          when 0
            glBegin(GL_QUADS)
            glTexCoord2f(@tex.u1, @tex.v1); glVertex3i(-100, 100, -100)
            glTexCoord2f(@tex.u2, @tex.v1); glVertex3i( 100, 100, -100)
            glTexCoord2f(@tex.u2, @tex.v2); glVertex3i( 100, 100,  100)
            glTexCoord2f(@tex.u1, @tex.v2); glVertex3i(-100, 100,  100)
            glEnd
            4.times do
              glTranslatef(0, 0, 100)
              glBegin(GL_QUADS)
              glTexCoord2f(@tex.u1, @tex.v1); glVertex3i(-100,  100, 0)
              glTexCoord2f(@tex.u2, @tex.v1); glVertex3i( 100,  100, 0)
              glTexCoord2f(@tex.u2, @tex.v2); glVertex3i( 100,  300, 0)
              glTexCoord2f(@tex.u1, @tex.v2); glVertex3i(-100,  300, 0)
              glEnd
              glTranslatef(0, 0, -100)
              glRotatef(90, 0, 1, 0)
            end
          when 1, 2
            glTranslatef(0, 20, 0)
            glBegin(GL_QUADS)
            glTexCoord2f(@tex.u1, @tex.v1); glVertex3i(-100, 100, -100)
            glTexCoord2f(@tex.u2, @tex.v1); glVertex3i( 100, 100, -100)
            glTexCoord2f(@tex.u2, @tex.v2); glVertex3i( 100, 100,  100)
            glTexCoord2f(@tex.u1, @tex.v2); glVertex3i(-100, 100,  100)
            glEnd
          when 3
            4.times do
              glTranslatef(0, 0, 100)
              glBegin(GL_QUADS)
              glTexCoord2f(@tex.u1, @tex.v1); glVertex3i(-100, -100, 0)
              glTexCoord2f(@tex.u2, @tex.v1); glVertex3i( 100, -100, 0)
              glTexCoord2f(@tex.u2, @tex.v2); glVertex3i( 100,  100, 0)
              glTexCoord2f(@tex.u1, @tex.v2); glVertex3i(-100,  100, 0)
              glEnd
              glTranslatef(0, 0, -100)
              glRotatef(90, 0, 1, 0)
            end
          else
            glBegin(GL_QUADS)
            glTexCoord2f(@tex.u1, @tex.v1); glVertex3i(-100, 100, -100)
            glTexCoord2f(@tex.u2, @tex.v1); glVertex3i( 100, 100, -100)
            glTexCoord2f(@tex.u2, @tex.v2); glVertex3i( 100, 100,  100)
            glTexCoord2f(@tex.u1, @tex.v2); glVertex3i(-100, 100,  100)
            glEnd
          end
          glPopMatrix
        end
      end
    end
    glEndList
  end
  def draw_test(rot, x, z)
    if !@list
      refresh_map_list
    end
    rot = 0.0 if rot == -0.0
    x = 0.0 if x == -0.0
    z = 0.0 if z == -0.0
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
    glPushMatrix
    glRotatef(rot, 0.0, 1.0, 0.0)
    begin
      glTranslatef(x, 0, z)
    rescue Exception
      p :err_pos, rot, x, z
      raise
    end
    glColor4d(1.0, 1.0, 1.0, 1.0)
    glCallList(@list)
    glPopMatrix
  end
  def update
    # 今のところ不要
  end
  def dispose
    if @list
      glDeleteLists(@list)
    end
  end
end
