#==============================================================================
#  GL_Texture
#------------------------------------------------------------------------------
# @OpenGL̃eNX`bvNXłB
#==============================================================================

class GL_Texture
  include OpenGL32, Glu32
  attr_reader :u1, :u2, :v1, :v2
  def initialize(bitmap)
    @bitmap = bitmap
    tw = 1 << (Math.log(@bitmap.width) / Math.log(2)).ceil
    th = 1 << (Math.log(@bitmap.height) / Math.log(2)).ceil
    @tex_id = glGenTextures
    glBindTexture(GL_TEXTURE_2D, @tex_id)
    # eNX`ݒȂ
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP)
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP)
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, tw, th, 0, GL_RGBA,
    GL_UNSIGNED_BYTE, "\0" * tw * th * 4)
    # eNX`ïꕔjɉ摜\t
    glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, @bitmap.width, @bitmap.height,
    GL_RGBA, GL_UNSIGNED_BYTE, @bitmap.data_address)
    # eNX`̉摜̂镔̑傫vZ
    @texture_w = @bitmap.width.to_f / tw
    @texture_h = @bitmap.height.to_f / tw
    @rect = Rect.new(0, 0, @bitmap.width, @bitmap.height)
    @tw = tw.to_f
    @th = th.to_f
  end
  def enable
    glEnable(GL_TEXTURE_2D)
    glBindTexture(GL_TEXTURE_2D, @tex_id)
    if block_given?
      yield
      disable
    end
  end
  def disable
    glDisable(GL_TEXTURE_2D)
  end
  def set_rect(x, y, width, height)
    @u1 = (x + 0.5) / @tw
    @u2 = (x + width + 0.5) / @tw
    @v1 = (@bitmap.height - y - 0.5) / @th
    @v2 = (@bitmap.height - y - height - 0.5) / @th
  end
end
