#==============================================================================
# ■ Scene_Dungeon
#------------------------------------------------------------------------------
# 　3Dダンション画面の処理を行うクラスです。
#==============================================================================

class Scene_Dungeon
  def init
    #!!!テスト用処理!!!
    $game_map.setup(100)
    $game_player.moveto(1, 13)
    #!!!テスト用処理ここまで!!!
    @sprite_opengl = Sprite_OpenGL.get
    @gl_dungeon = GL_Dungeon.new
    @x = $game_player.x * 200
    @z = $game_player.y * 200
    self.rot = 180
    @move_frame_max = 3.0
    @move_count = 0
    @mini_window = Window_Mini.new
    @mini_window.battler = $game_party.actors[0]
    @mini_window.update
  end
  def rot=(rot)
    @rot = rot
    case @rot
    when 0
      @dx = 0
      @dz = 200
    when 90
      @dx = 200
      @dz = 0
    when 180
      @dx = 0
      @dz = -200
    when 270
      @dx = -200
      @dz = 0
    else
      raise "#{@rot} は角度として扱えません"
    end
  end
  def main
    init
    # トランジション実行
    Graphics.transition
    
    loop do
      # 入力情報を更新
      Input.update
      # フレーム更新
      update
      # ゲーム画面を更新
      Graphics.update
      # 画面が切り替わったらループを中断
      if $scene != self
        break
      end
    end
    dispose
    # トランジション準備
    Graphics.freeze
  end
  def update
    if @move_count
      drot = dx = dz = 0
      @move_count += 1
      move_rate = @move_count / @move_frame_max
      case @dir
      when 4
        drot = -90 * move_rate
      when 6
        drot = 90 * move_rate
      when 2
        drot = 180 * move_rate
      when 8
        dx = @dx * move_rate
        dz = @dz * move_rate
      when nil
        @dir = 0
        @move_count = nil
      end
      #p [drot, dx, dz]
      @gl_dungeon.draw_test(@rot + drot, -(@x + dx), @z + dz)
      @sprite_opengl.refresh
      if @move_count == @move_frame_max
        #@dir = 0
        @move_count = nil
        self.rot = (@rot + drot.to_i) % 360
        @x += dx.to_i
        @z += dz.to_i
      end
    else
      dir = Input.dir4
      unless dir == 8 &&
             $game_map.data[(@x + @dx) / 200, (@z + @dz) / 200, 0] != 384
        unless dir == @dir && [2,4,6].include?(dir)
          @dir = dir
          if dir != 0
            @move_count = 0
          end
        end
      end
    end
    @gl_dungeon.update
    @sprite_opengl.update
    @mini_window.update
  end
  def dispose
    @sprite_opengl.dispose
    @gl_dungeon.dispose
  end
end
