#==============================================================================
# ■ Sprite_Actor
#------------------------------------------------------------------------------
# 　アクター表示用のスプライトです。Game_Actor クラスのインスタンスを監視し、
# スプライトの状態を自動的に変化させます。
#==============================================================================

class Sprite_Actor < Sprite_Battler
  #--------------------------------------------------------------------------
  # ● ビットマップの更新
  #     返り値：更新されたかどうか
  #--------------------------------------------------------------------------
  def update_bitmap?
    # ファイル名か色相が現在のものと異なる場合
    if @battler.character_name != @battler_name or
       @battler.character_hue != @battler_hue
      # ビットマップを取得、設定
      @battler_name = @battler.character_name
      @battler_hue = @battler.character_hue
      self.bitmap = RPG::Cache.character(@battler_name, @battler_hue)
      @width = bitmap.width
      @height = bitmap.height
      self.ox = @width
      self.oy = @height
      return true
    else
      return false
    end
  end
  #--------------------------------------------------------------------------
  # ● スプライト座標の設定
  #--------------------------------------------------------------------------
  def set_pos
    # ミニウィンドウから設定するのでここでは何もしない
  end
end
