#==============================================================================
# ■ Sprite_OpenGL
#------------------------------------------------------------------------------
# 　OpenGL描画用のスプライトです。実際のスプライトは内部に持ちます。
#==============================================================================

class Sprite_OpenGL
  include OpenGL32, Glu32
  @@instance = nil
  class << self
    private :new
    def get
      unless @@instance
        @@instance = new
      end
      return @@instance
    end
  end
  def initialize
    @sprite = Sprite.new
    @bitmap = Bitmap.new(Graphics.width, Graphics.height)
    @sprite.bitmap = @bitmap
    # OpenGL 初期化
    @hwnd = User32.GetForegroundWindow
    @hdc = User32.GetDC(@hwnd)
    pixel_format = Gdi32.ChoosePixelFormat(@hdc, GL_PFD)
    Gdi32.SetPixelFormat(@hdc, pixel_format, GL_PFD)
    @hrc = wglCreateContext(@hdc)
    unless wglMakeCurrent(@hdc, @hrc)
      raise "OpenGL initialize error"
    end
    glDepthFunc(GL_LESS)
    glEnable(GL_DEPTH_TEST)
    glEnable(GL_FOG)
    glFogi(GL_FOG_MODE , GL_LINEAR)
    glFogi(GL_FOG_START , 10)
    glFogi(GL_FOG_END , 18)

    w, h = Graphics.width, Graphics.height
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity
    glTranslatef(0, 0.35, 0)
    gluPerspective(60, 1, 1.0, 20)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity
    glScalef(0.01, -0.01, 0.01)
    glTranslatef(0, 0, -100)
 end
  def update
    #sleep 0.001
    #Graphics.frame_reset
  end
  def refresh
    glReadPixels(0, 0, @bitmap.width, @bitmap.height,
                 GL_RGBA, GL_UNSIGNED_BYTE, @bitmap.data_address)
  end
  def dispose
    @bitmap.dispose
    @sprite.dispose
    
    # OpenGL 終了
    wglMakeCurrent(@hdc, 0)
    wglDeleteContext(@hrc)
    User32.ReleaseDC(@hwnd, @hdc)
    @@instance = nil
  end
end
