##=====================================================================
## class T_Cursor
##=====================================================================
class T_Cursor
  attr_accessor :x
  attr_accessor :y
  attr_accessor :z
  OPA_MAX = 128
  OPA_MIN = 64
  OPA_STOP = 96
  OPA_D = -4
  TONE_MAX = 0
  TONE_MIN = -255
  TONE_STOP = -128
  TONE_D = -16
  ##=====================================================================
  ## initialize
  ##=====================================================================
  def initialize(x, y, z, filename)
    @x = x
    @y = y
    @z = z
    @opa_d = OPA_D
    @tone_d = TONE_D
    @isStop = false
    @activate = false
    ##-------------- 白 --------------
    @spr0 = Sprite.new
    @spr0.bitmap = RPG::Cache.load_bitmap("", filename)
    w = @spr0.bitmap.rect.width
    hh = @spr0.bitmap.rect.height / 2
    @spr0.x = @x
    @spr0.y = @y
    @spr0.z = @z
    @spr0.src_rect = Rect.new(0, 0, w, hh)
    @spr0.opacity = OPA_MAX
    @spr0.visible = false
    ##-------------- 枠 --------------
    @spr1 = Sprite.new
    @spr1.bitmap = @spr0.bitmap
    @spr1.x = @x
    @spr1.y = @y
    @spr1.z = @z + 1
    @spr1.src_rect = Rect.new(0, hh, w, hh)
    @spr1.visible = false
  end
  ##=====================================================================
  ## update
  ##=====================================================================
  def update
    if @spr0.x != @x
      @spr0.x = @x
      @spr1.x = @x
    end
    if @spr0.y != @y
      @spr0.y = @y
      @spr1.y = @y
    end
    if @spr0.z != @z
      @spr0.z = @z
      @spr1.z = @z + 1
    end
    if !@isStop && @activate
      ##-------------- 白アニメ --------------
      @spr0.opacity += @opa_d
      if @spr0.opacity <= OPA_MIN
        @spr0.opacity = OPA_MIN
        @opa_d = -@opa_d
      end
      if @spr0.opacity >= OPA_MAX
        @spr0.opacity = OPA_MAX
        @opa_d = -@opa_d
      end
      ##-------------- 枠アニメ --------------
      @spr1.tone.red   += @tone_d
      @spr1.tone.green += @tone_d
      if @spr1.tone.red <= TONE_MIN
        @spr1.tone.red   = TONE_MIN
        @spr1.tone.green = TONE_MIN
        @tone_d = -@tone_d
      end
      if @spr1.tone.red >= TONE_MAX
        @spr1.tone.red   = TONE_MAX
        @spr1.tone.green = TONE_MAX
        @tone_d = -@tone_d
      end
    end
  end
  ##=====================================================================
  ## stop
  ##=====================================================================
  def stop
    @isStop = true
    @spr1.opacity = OPA_STOP
    @spr1.tone.red = TONE_STOP
    @spr1.tone.green = TONE_STOP
  end
  ##=====================================================================
  ## start
  ##=====================================================================
  def start
    @isStop = false
  end
  ##=====================================================================
  ## active_switch
  ##=====================================================================
  def active_switch(active)
    @activate = active
    @spr1.opacity = OPA_STOP
    @spr1.tone.red = TONE_STOP
    @spr1.tone.green = TONE_STOP
    @spr0.visible = active
    @spr1.visible = active
  end
  ##=====================================================================
  ## dispose
  ##=====================================================================
  def dispose
    @spr0.bitmap.dispose
    @spr0.dispose
    @spr1.bitmap.dispose
    @spr1.dispose
  end
end # class T_Cursor  
