##---------------------------------------------------------------------
## Tarna01.rb   UTF-8で保存すること
##
##$: << File.expand_path("./")
##require "./Scripts/Tarna01.rb"
##test01
###test02
##---------------------------------------------------------------------



##---------------------------------------------------------------------
## class Battle_Command_Sub_Window
##---------------------------------------------------------------------
class Battle_Command_Sub_Window
  ##---------------------------------------------------------------------
  ## initialize
  ##---------------------------------------------------------------------
  def initialize(x, y, z, bmp, text)
    @x = x;
    @y = y;
    @w = 150
    @h = 24
    @bmp = bmp
    @text = text
    ##-------------- 背景sprite --------------
    @spr = Sprite.new
    @spr.bitmap = bmp
    @spr.src_rect = Rect.new(0, 0, 150, 24)
    @spr.x = x
    @spr.y = y
    @spr.z = z
    ##-------------- フォントbitmap --------------
    @bmp_font = Bitmap.new(@w, @h)
    @bmp_font.font.size = 16
    # @bmp_font.font.color = Color.new(0xff, 0xff, 0xff, 0xff)
    @bmp_font.draw_text(0, 0, 150, 24, text, 1) # 最後のパラメーターは中央揃え
    ##-------------- フォントsprite --------------
    @spr_font = Sprite.new
    @spr_font.bitmap = @bmp_font
    @spr_font.src_rect = @spr.src_rect
    @spr_font.x = x
    @spr_font.y = y
    @spr_font.z = z + 1
  end
  ##---------------------------------------------------------------------
  ## dispose
  ##---------------------------------------------------------------------
  def dispose
    @spr.dispose
    @spr = nil
    @spr_font.dispose
    @spr_font = nil
    @bmp_font.dispose
    @bmp_font = nil
  end
end # class Battle_Command_Sub_Window

##---------------------------------------------------------------------
## class Battle_Command_Window
##---------------------------------------------------------------------
class Battle_Command_Window
  ##---------------------------------------------------------------------
  ## initialize
  ##---------------------------------------------------------------------
  def initialize(x, y, texts)
    @x = x
    @y = y
    @Z = 4000
    @size = texts.size
    @index = 0
    @bmp_sub = RPG::Cache.load_bitmap("Graphics/Pictures/battle/", "戦闘行動選択背景")
    ##-------------- カーソル --------------
    @cur = T_Cursor.new(x, y, @Z, "Graphics/Pictures/battle/戦闘行動選択カーソル")
    ##-------------- sub_window --------------
    @sub_win = []
    yy = y;
    for i in 0...@size
      @sub_win.push(Battle_Command_Sub_Window.new(x, yy, @Z - 1, @bmp_sub, texts[i]))
      yy += 24
    end
  end
  ##---------------------------------------------------------------------
  ## dispose
  ##---------------------------------------------------------------------
  def dispose
    @sub_win.each {|s| s.dispose}
    @cur.dispose
  end
  ##---------------------------------------------------------------------
  ## update
  ##---------------------------------------------------------------------
  def update
    ##-------------- 上押された --------------
    if Input::repeat?(Input::UP)
      @index -= 1
      if @index < 0
        @index = @size - 1
      end
      @cur.y = @y + 24 * @index
    end
    ##-------------- 下押された --------------
    if Input::repeat?(Input::DOWN)
      @index += 1
      if @index >= @size
        @index = 0
      end
      @cur.y = @y + 24 * @index
    end
    ##-------------- キャンセル押された --------------
    if Input::trigger?(Input::B)
      return false
    end
    @cur.update
    ##-------------- 正常終了（つづく） --------------
    true
  end
end # class Battle_Command_Window

##---------------------------------------------------------------------
## module T_Cache
##---------------------------------------------------------------------
module T_Cache
  @bmps = {}
  ##---------------------------------------------------------------------
  ## load
  ##---------------------------------------------------------------------
  def self.load(filename)
    if @bmps.include?(filename)
      @bmps[filename]
    else
      @bmps[filename] = RPG::Cache.load_bitmap("Graphics/Pictures/", filename)
    end
  end
  ##---------------------------------------------------------------------
  ## clear
  ##---------------------------------------------------------------------
  def self.clear
    @bmps.each_value {|bmp|
      bmp.dispose
      bmp = nil
    }
    @bmps = {}
  end
end # module T_Cache

##---------------------------------------------------------------------
## module T_Event_Key 
##---------------------------------------------------------------------
module T_Event_Key
  WAIT_1ST = 7 # リピート間隔１回目
  WAIT_NEXT = 3 # リピート間隔2回目以降
  ##---------------------------------------------------------------------
  ## init 
  ##---------------------------------------------------------------------
  def self.init(wait_1st = WAIT_1ST, wait_next = WAIT_NEXT)
    @wait_1st = wait_1st
    @wait_next = wait_next
    @prev = []
    @count = []
    for i in 0..12
      @prev[i] = 0
      @count[i] = 0
    end
  end
  ##---------------------------------------------------------------------
  ## get 
  ##---------------------------------------------------------------------
  def self.get
    # C
    if Input.press?(Input::C)
      if @count[12] == 0
        @count[12] = 1
        return 12
      end
    else
      @count[12] = 0
    end
    # B
    if Input.press?(Input::B)
      if @count[11] == 0
        @count[11] = 1
        return 11
      end
    else
      @count[11] = 0
    end
    # A
    if Input.press?(Input::A)
      if @count[10] == 0
        @count[10] = 1
        return 10
      end
    else
      @count[10] = 0
    end
    # UP
    if Input.press?(Input::UP)
      if @count[8] > 0
        @count[8] -= 1
        if @count[8] == 0
          @count[8] = @wait_next
          return 8
        end
      else
        @count[8] = @wait_1st
        return 8
      end
    else
      @count[8] = 0
    end
    # DOWN
    if Input.press?(Input::DOWN)
      if @count[2] > 0
        @count[2] -= 1
        if @count[2] == 0
          @count[2] = @wait_next
          return 2
        end
      else
        @count[2] = @wait_1st
        return 2
      end
    else
      @count[2] = 0
    end
    return 0
  end
end

##---------------------------------------------------------------------
## class Status_Soubi
##---------------------------------------------------------------------
class Status_Soubi
  attr_reader :stat
  ##---------------------------------------------------------------------
  ## initialize
  ##---------------------------------------------------------------------
  def initialize
    @stat = 0
    @spr_base = Sprite.new
    @spr_base.x = 0
    @spr_base.y = 0
    @spr_base.z = 4000 - 1
    @spr_base.bitmap = T_Cache.load("menu/status/StatusSoubi")
    @spr_base.src_rect = Rect.new(0, 0, 640, 480)
  end
  ##---------------------------------------------------------------------
  ## update
  ##---------------------------------------------------------------------
  def update
  end
  ##---------------------------------------------------------------------
  ## dispose
  ##---------------------------------------------------------------------
  def dispose
    @spr_base.dispose
  end
end # class Status_Soubi

##---------------------------------------------------------------------
## class Status_Skill
##---------------------------------------------------------------------
class Status_Skill
  attr_reader :stat
  ##---------------------------------------------------------------------
  ## initialize
  ##---------------------------------------------------------------------
  def initialize
    @stat = 0
    @spr_base = Sprite.new
    @spr_base.x = 0
    @spr_base.y = 0
    @spr_base.z = 4000 - 1
    @spr_base.bitmap = T_Cache.load("menu/status/StatusSkill")
    @spr_base.src_rect = Rect.new(0, 0, 640, 480)
  end
  ##---------------------------------------------------------------------
  ## update
  ##---------------------------------------------------------------------
  def update
  end
  ##---------------------------------------------------------------------
  ## dispose
  ##---------------------------------------------------------------------
  def dispose
    @spr_base.dispose
  end
end # class Status_Skill

##---------------------------------------------------------------------
## class Status_Retuden
##---------------------------------------------------------------------
class Status_Retuden
  attr_reader :stat
  ##---------------------------------------------------------------------
  ## initialize
  ##---------------------------------------------------------------------
  def initialize
    @stat = 0
    @spr_base = Sprite.new
    @spr_base.x = 0
    @spr_base.y = 0
    @spr_base.z = 4000 - 1
    @spr_base.bitmap = T_Cache.load("menu/status/StatusRetuden")
    @spr_base.src_rect = Rect.new(0, 0, 640, 480)
  end
  ##---------------------------------------------------------------------
  ## update
  ##---------------------------------------------------------------------
  def update
  end
  ##---------------------------------------------------------------------
  ## dispose
  ##---------------------------------------------------------------------
  def dispose
    @spr_base.dispose
  end
end # class Status_Retuden

##---------------------------------------------------------------------
## class Status_Top_Icons
##---------------------------------------------------------------------
class Status_Top_Icons
  Z = 4000 + 2
  ##---------------------------------------------------------------------
  ## initialize
  ##---------------------------------------------------------------------
  def initialize
    v = 0
    if $option.is_pad
      v = 16
    end
    @bmp = T_Cache.load("keyicon")
    # キャラ矢印
    @scly = Sprite.new # キャラ変更左矢印
    @scly.bitmap = @bmp
    @scly.x = 9 + 0
    @scly.y = 155
    @scly.z = Z
    @scly.src_rect = Rect.new(0, 32, 16, 16)
    @scry = Sprite.new # キャラ変更右矢印
    @scry.bitmap = @bmp
    @scry.x = 171 - 16 + 2
    @scry.y = 155
    @scry.z = Z
    @scry.src_rect = Rect.new(16, 32, 16, 16)
    # キャラボタン
    @scli = Sprite.new # キャラ変更左ボタン
    @scli.bitmap = @bmp
    @scli.x = @scly.x + 16
    @scli.y = 156
    @scli.z = Z
    @scli.src_rect = Rect.new(96, v, 16, 16) # L
    @scri = Sprite.new # キャラ変更右ボタン
    @scri.bitmap = @bmp
    @scri.x = @scry.x - 16
    @scri.y = 156
    @scri.z = Z
    @scri.src_rect = Rect.new(112, v, 16, 16) # R
    ####################3
    # ステータス矢印
    @ssly = Sprite.new # ステータス変更左矢印
    @ssly.bitmap = @bmp
    @ssly.x = 342
    @ssly.y = 10
    @ssly.z = Z
    @ssly.src_rect = Rect.new(0, 32, 16, 16)
    @ssry = Sprite.new # ステータス変更右矢印
    @ssry.bitmap = @bmp
    @ssry.x = 630 - 16
    @ssry.y = 10
    @ssry.z = Z
    @ssry.src_rect = Rect.new(16, 32, 16, 16)
    # ステータスボタン
    @ssli = Sprite.new # ステータス変更左ボタン
    @ssli.bitmap = @bmp
    @ssli.x = @ssly.x + 16
    @ssli.y = 11
    @ssli.z = Z
    @ssli.src_rect = Rect.new(64, v, 16, 16) # L
    @ssri = Sprite.new # ステータス変更右ボタン
    @ssri.bitmap = @bmp
    @ssri.x = @ssry.x - 16
    @ssri.y = 11
    @ssri.z = Z
    @ssri.src_rect = Rect.new(80, v, 16, 16) # R
  end
  ##---------------------------------------------------------------------
  ## dispose
  ##---------------------------------------------------------------------
  def dispose
    @scly.bitmap.dispose
    @scry.bitmap.dispose
    @scli.bitmap.dispose
    @scri.bitmap.dispose
  end
end

##---------------------------------------------------------------------
## class Status_Top
##---------------------------------------------------------------------
class Status_Top
  ##---------------------------------------------------------------------
  ## initialize
  ##---------------------------------------------------------------------
  def initialize(n)
    @face = Sprite.new
    @face.x = 6
    @face.y = 6
    @face.z = 4000
    @face.src_rect = Rect.new(0, 0, 170, 170)
    @face_over = Sprite.new
    @face_over.bitmap = T_Cache.load("menu/status/Status顔上")
    @face_over.x = 6
    @face_over.y = 6
    @face_over.z = 4000 + 1
    @face_over.src_rect = Rect.new(0, 0, 170, 170)
    @fonts = Sprite.new
    @fonts.x = 0
    @fonts.y = 0
    @fonts.z = 4000 + 2
    @fonts.src_rect = Rect.new(0, 0, 640, 175)
    @n = n
    @isSoubi = true
    @icons = Status_Top_Icons.new
    set_face
    set_fonts
  end
  ##---------------------------------------------------------------------
  ## change_chara
  ##---------------------------------------------------------------------
  def change_chara(n)
    @n = n
    set_face()
    set_fonts
  end
  ##---------------------------------------------------------------------
  ## set_face
  ##---------------------------------------------------------------------
  def set_face
    @s_data = ["002", "032", "025", "047"] # 本来はparty,actor内から取得
    s = "fm" + @s_data[@n]
    @face.bitmap = T_Cache.load(s)
  end
  ##---------------------------------------------------------------------
  ## set_isSoubi
  ##---------------------------------------------------------------------
  def set_isSoubi(f)
    @isSoubi = f
  end
  ##---------------------------------------------------------------------
  ## set_fonts
  ##---------------------------------------------------------------------
  def set_fonts
    data = [
    [
    99, "レナ", 9, 9999, "超能力者", 9, 9, 99999, # Lv, 名前, LP, HP, 職業, EP, SP, NEXT
    999, 999, 999, 999, 999, 999, # 体力, 知力, 魔力, 技術, 敏捷, 精神
    1234, 5678, 9012, 3456, # 主単, 主計, 補単, 補計
    999, 999, 999, 999, # 耐久力, 命中力, 回避力, 機動力
    99, # 重量限界
    1, 0, 0, 0, -1 # 耐久属性
    ],
    [
    99, "セオリオード", 9, 9999, "超能力者", 9, 9, 99999, # Lv, 名前, LP, HP, 職業, EP, SP, NEXT
    999, 999, 999, 999, 999, 999, # 体力, 知力, 魔力, 技術, 敏捷, 精神
    1234, 5678, 9012, 3456, # 主単, 主計, 補単, 補計
    999, 999, 999, 999, # 耐久力, 命中力, 回避力, 機動力
    99, # 重量限界
    1, 0, 0, 0, -1 # 耐久属性
    ],
    [
    10, "ビャクエン", 8, 256, "聖騎士", 5, 3, 32,
    20, 30, 40, 50, 60, 70,
    100, 120, 140, 160,
    100, 10, 20, 30,
    50,
    0, 1, 1, 0, 0
    ],
    [
    8, "セオラル", 6, 80, "軍師", 6, 4, 10001,
    80, 90, 100, 77, 21, 123,
    1001, 2002, 3003, 4004,
    20, 3, 4, 5,
    9,
    -1, -1, -1, 1, 1
    ]
    ]

    if @fonts.bitmap == nil
      @fonts.bitmap = Bitmap.new(640, 175)
    else
      @fonts.bitmap.clear
    end
    gothic = "ＭＳ ゴシック"
    pgothic = "ＭＳ Ｐゴシック"
    @fonts.bitmap.font.name = gothic
    @fonts.bitmap.font.color = Color.new(0xff, 0xff, 0xff, 0xff)
    r = Rect.new(0, 0, 80, 16)
    d = data[@n]
    #-------------------
    # 名前
    r.x = 10
    r.y = 155
    r.width = 162
    s = d[1]
    @fonts.bitmap.font.name = pgothic
    @fonts.bitmap.font.size = 16
    @fonts.bitmap.draw_text(r, s, 1)
    #-------------------
    # LV
    @fonts.bitmap.font.name = gothic
    r.x = 204
    r.y = 17
    r.width = 80
    s = to_s(d[0], 2)
    @fonts.bitmap.draw_text(r, s)
    # 職業
    r.x = 246
    r.y -= 1
    s = d[4]
    @fonts.bitmap.font.name = pgothic
    @fonts.bitmap.draw_text(r, s)
    @fonts.bitmap.font.name = gothic
    #-------------------
    # 体力
    xx = r.x = 229
    yy = r.y = 37
    s = to_s(d[8], 3)
    @fonts.bitmap.draw_text(r, s)
    # 知力
    r.x += 100
    s = to_s(d[10], 3)
    @fonts.bitmap.draw_text(r, s)
    # 魔力
    r.x += 100
    s = to_s(d[9], 3)
    @fonts.bitmap.draw_text(r, s)

    # 技術
    r.x = xx
    r.y += 20
    s = to_s(d[11], 3)
    @fonts.bitmap.draw_text(r, s)
    # 敏捷
    r.x += 100
    s = to_s(d[12], 3)
    @fonts.bitmap.draw_text(r, s)
    # 精神
    r.x += 100
    s = to_s(d[13], 3)
    @fonts.bitmap.draw_text(r, s)
    if @isSoubi
      # 魔力
      r.x = xx + 234
      r.y = yy
      @fonts.bitmap.draw_text(r, "→")
      # 精神
      r.y += 20
      @fonts.bitmap.draw_text(r, "→")
      ##--------------
      # 魔力
      r.x = xx + 258
      r.y = yy
      s = to_s(d[9], 3)
      @fonts.bitmap.draw_text(r, s)
      # 精神
      r.y += 20
      s = to_s(d[13], 3)
      @fonts.bitmap.draw_text(r, s)
    end
    ##--------------
    # HP
    xx = r.x = 221
    yy = r.y = 76
    s = to_s(d[3], 4)
    @fonts.bitmap.draw_text(r, s)
    # LP
    r.y += 20
    s = to_s(d[2], 1)
    @fonts.bitmap.draw_text(r, s)
    r.x = xx + 20
    s = to_s(d[2], 1)
    @fonts.bitmap.draw_text(r, s)
    # SP
    r.x = xx
    r.y += 20
    s = to_s(d[5], 1)
    @fonts.bitmap.draw_text(r, s)
    r.x = xx + 20
    s = to_s(d[5], 1)
    @fonts.bitmap.draw_text(r, s)
    # EP
    r.x = xx
    r.y += 20
    s = to_s(d[6], 1)
    @fonts.bitmap.draw_text(r, s)
    r.x = xx + 20
    s = to_s(d[6], 1)
    @fonts.bitmap.draw_text(r, s)
    ##--------------
    # 主単
    xx = r.x = 348
    yy = r.y = 76
    s = to_s(d[14], 4)
    @fonts.bitmap.draw_text(r, s)
    # 主計
    r.y += 20
    s = to_s(d[15], 4)
    @fonts.bitmap.draw_text(r, s)
    # 補単
    r.y += 20
    s = to_s(d[16], 4)
    @fonts.bitmap.draw_text(r, s)
    # 補計
    r.y += 20
    s = to_s(d[17], 4)
    @fonts.bitmap.draw_text(r, s)
    if @isSoubi
      # 主単
      r.x = xx + 42
      r.y = yy
      @fonts.bitmap.draw_text(r, "→")
      # 主計
      r.y += 20
      @fonts.bitmap.draw_text(r, "→")
      # 補単
      r.y += 20
      @fonts.bitmap.draw_text(r, "→")
      # 補計
      r.y += 20
      @fonts.bitmap.draw_text(r, "→")
      ##----------------
      # 主単
      r.x = xx + 66
      r.y = yy
      s = to_s(d[14], 4)
      @fonts.bitmap.draw_text(r, s)
      # 主計
      r.y += 20
      s = to_s(d[15], 4)
      @fonts.bitmap.draw_text(r, s)
      # 補単
      r.y += 20
      s = to_s(d[16], 4)
      @fonts.bitmap.draw_text(r, s)
      # 補計
      r.y += 20
      s = to_s(d[17], 4)
      @fonts.bitmap.draw_text(r, s)
    end
    # 耐久力
    xx = r.x = 546
    yy = r.y = 76
    s = to_s(d[18], 3)
    @fonts.bitmap.draw_text(r, s)
    # 命中力
    r.y += 20
    s = to_s(d[19], 3)
    @fonts.bitmap.draw_text(r, s)
    # 回避力
    r.y += 20
    s = to_s(d[20], 3)
    @fonts.bitmap.draw_text(r, s)
    # 機動力
    r.y += 20
    s = to_s(d[21], 3)
    @fonts.bitmap.draw_text(r, s)
    if @isSoubi
      # 耐久力
      r.x = xx + 33
      r.y = yy
      @fonts.bitmap.draw_text(r, "→")
      # 命中力
      r.y += 20
      @fonts.bitmap.draw_text(r, "→")
      # 回避力
      r.y += 20
      @fonts.bitmap.draw_text(r, "→")
      # 機動力
      r.y += 20
      @fonts.bitmap.draw_text(r, "→")
      ##----------------
      # 耐久力
      r.x = xx + 58
      r.y = yy
      s = to_s(d[18], 3)
      @fonts.bitmap.draw_text(r, s)
      # 命中力
      r.y += 20
      s = to_s(d[19], 3)
      @fonts.bitmap.draw_text(r, s)
      # 回避力
      r.y += 20
      s = to_s(d[20], 3)
      @fonts.bitmap.draw_text(r, s)
      # 機動力
      r.y += 20
      s = to_s(d[21], 3)
      @fonts.bitmap.draw_text(r, s)
    end
    # NEXT
    r.x = xx = 221
    r.y = yy = 155
    s = to_s(d[7], 5)
    @fonts.bitmap.draw_text(r, s)
    ##----------------
    # 全備重量
    xx = r.x = 397
    s = to_s(d[22], 2)
    @fonts.bitmap.draw_text(r, s)
    # 限界
    r.x = xx + 32
    s = to_s(d[22], 2)
    @fonts.bitmap.draw_text(r, s)
    ##----------------
    # 耐久属性
    @fonts.bitmap.font.name = pgothic
    col_w = Color.new(0xff, 0xff, 0xff, 0xff)
    col_g = Color.new(0x80, 0x80, 0x80, 0xff)
    col_r = Color.new(0xc0, 0x00, 0x00, 0xff)
    zokusei = ["火","雷","氷","身体","精神"]
    xx = [480, 505, 530, 556, 596]
    for i in 0...5
      case d[23 + i]
      when 1
        col = col_w
      when 0
        col = col_g
      when -1
        col = col_r
      end
      @fonts.bitmap.font.color = col
      r.x = xx[i]
      @fonts.bitmap.draw_text(r, zokusei[i])
    end
    @fonts.bitmap.font.name = gothic
  end
  ##---------------------------------------------------------------------
  ## to_s
  ##---------------------------------------------------------------------
  def to_s(n, len)
    s = "    " + n.to_s
    s[s.length - len, len]
  end
  ##---------------------------------------------------------------------
  ## update
  ##---------------------------------------------------------------------
  def update
  end
  ##---------------------------------------------------------------------
  ## dispose
  ##---------------------------------------------------------------------
  def dispose
    @icons.dispose
    @face.dispose
    @face = nil
    @fonts.bitmap.dispose
    @fonts.bitmap = nil
    @fonts.dispose
    @fonts = nil
  end
end # class Status_Top

##---------------------------------------------------------------------
## class Status_Gamen
##---------------------------------------------------------------------
class Status_Gamen
  MODE_SOUBI   = 0
  MODE_GINOU   = 1
  MODE_SYOUSAI = 2
  MODE_MAX = MODE_SYOUSAI
  CUR_SX = 396
  CUR_SY = 8
  CUR_ADD_X = 68
  ##---------------------------------------------------------------------
  ## initialize
  ##---------------------------------------------------------------------
  def initialize
    @mode = MODE_SOUBI
    @chara = 0
    @chara_max = 3
    @top = Status_Top.new(0)
    change_sub
    @cur = T_Cursor.new(CUR_SX, CUR_SY, 4000, "Graphics/Pictures/menu/status/StatusCursor")
    #    @cur.stop
    @cur.active_switch(true)
  end
  ##---------------------------------------------------------------------
  ## update
  ##---------------------------------------------------------------------
  def update
    if @sub.stat == 0
      if Input::trigger?(Input::B)
        return false
      end
      if Input::trigger?(Input::Y)
        @mode -= 1
        if @mode < 0
          @mode = MODE_MAX
        end
        @cur.x = CUR_SX + CUR_ADD_X * @mode
        change_sub
      end
      if Input::trigger?(Input::Z)
        @mode += 1
        if @mode > MODE_MAX
          @mode = 0
        end
        @cur.x = CUR_SX + CUR_ADD_X * @mode
        change_sub
      end
      if Input::trigger?(Input::L)
        @chara -= 1
        if @chara < 0
          @chara = @chara_max
        end
        @top.change_chara(@chara)
      end
      if Input::trigger?(Input::R)
        @chara += 1
        if @chara > @chara_max
          @chara = 0
        end
        @top.change_chara(@chara)
      end
    end
    @cur.update
    @sub.update
    @top.update
    true
  end
  ##---------------------------------------------------------------------
  ## change_sub 装備、スキル、列伝の切り替え
  ##---------------------------------------------------------------------
  def change_sub
    if @sub != nil
      @sub.dispose
      @sub = nil
    end
    case @mode
    when MODE_SOUBI
      @sub = Status_Soubi.new
      @top.set_isSoubi(true)
      @top.set_fonts
    when MODE_GINOU
      @sub = Status_Skill.new
      @top.set_isSoubi(false)
      @top.set_fonts
    when MODE_SYOUSAI
      @sub = Status_Retuden.new
      @top.set_isSoubi(false)
      @top.set_fonts
    end
  end
  ##---------------------------------------------------------------------
  ## dispose
  ##---------------------------------------------------------------------
  def dispose
    @cur.dispose
    @sub.dispose
    @top.dispose
  end
end # class Status_Gamen

##---------------------------------------------------------------------
## Dungeon 
##---------------------------------------------------------------------
class Dungeon
  BUFF_SIZE = 25
  SPR_BUFF_SIZE = BUFF_SIZE * 3 # 各マスは最大で壁画像２枚＋宝箱などのオブジェクト１枚＝３枚使用
  DISP_Z = 900

  ##---------------------------------------------------------------------
  ## initialize 
  ##---------------------------------------------------------------------
  def initialize
    # 見える範囲 数字は描画順序
    # +---+---+---+---+---+---+---+
    # | 00| 02| 04| 06| 05| 03| 01|  ここは手前の壁だけ（壁じゃないときは描画しない）
    # +---+---+---+---+---+---+---+
    # | 07| 09| 11| 13| 12| 10| 08|
    # +---+---+---+---+---+---+---+
    # | x | 14| 16| 18| 17| 15| x |
    # +---+---+---+---+---+---+---+
    # | x | x | 19| 21| 20| x | x |
    # +---+---+---+---+---+---+---+
    # | x | x | 22|*24| 23| x | x |
    # +---+---+---+---+---+---+---+
    @zahyo = [
    # 0 壁
    # 手前向きの壁              側面の壁                  宝箱、階段など
    #   u   v   w   h   x   y
    [[589,633, 21,114,  0, 82],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 00
    [[490,633, 21,114,619, 82],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 01
    [[490,633,120,114, 21, 82],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 02
    [[490,633,120,114,499, 82],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 03
    [[490,633,120,114,140, 82],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 04
    [[490,633,120,114,379, 82],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 05
    [[490,633,120,114,259, 82],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 06

    [[ -1, -1, -1, -1, -1, -1],[820,493, 21,122,  0, 79],[ -1, -1, -1, -1, -1, -1]], # 07
    [[ -1, -1, -1, -1, -1, -1],[841,493, 23,122,617, 79],[ -1, -1, -1, -1, -1, -1]], # 08
    [[575,480, 77,153,  0, 66],[694,480, 63,153, 77, 66],[ -1, -1, -1, -1, -1, -1]], # 09
    [[490,480, 78,153,562, 66],[757,480, 63,153,498, 66],[ -1, -1, -1, -1, -1, -1]], # 10
    [[490,480,162,153, 77, 66],[652,480, 21,153,238, 66],[ -1, -1, -1, -1, -1, -1]], # 11
    [[490,480,162,153,400, 66],[673,480, 21,153,379, 66],[ -1, -1, -1, -1, -1, -1]], # 12
    [[490,480,162,153,238, 66],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 13

    [[ -1, -1, -1, -1, -1, -1],[334,494, 77,203,  0, 45],[ -1, -1, -1, -1, -1, -1]], # 14
    [[ -1, -1, -1, -1, -1, -1],[411,494, 79,203,561, 45],[ -1, -1, -1, -1, -1, -1]], # 15
    [[ 53,480,195,236,  0, 31],[248,480, 43,236,195, 31],[ -1, -1, -1, -1, -1, -1]], # 16
    [[  0,480,197,236,443, 31],[291,480, 43,236,400, 31],[ -1, -1, -1, -1, -1, -1]], # 17
    [[  0,480,248,236,195, 31],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 18

    [[591,  0, 49,427,  0,  0],[640,  0,146,427, 49,  0],[ -1, -1, -1, -1, -1, -1]], # 19
    [[100,  0, 51,427,589,  0],[786,  0,146,427,443,  0],[ -1, -1, -1, -1, -1, -1]], # 20
    [[100,  0,540,427, 49,  0],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 21

    [[ -1, -1, -1, -1, -1, -1],[  0,  0, 49,480,  0,  0],[ -1, -1, -1, -1, -1, -1]], # 22
    [[ -1, -1, -1, -1, -1, -1],[ 49,  0, 51,480,589,  0],[ -1, -1, -1, -1, -1, -1]], # 23
    [[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 24
    ],
    [
    # 見える範囲 数字は描画順序
    # +---+---+---+---+---+---+---+
    # | 00| 02| 04| 06| 05| 03| 01|  ここは手前の壁だけ（壁じゃないときは描画しない）
    # +---+---+---+---+---+---+---+
    # | 07| 09| 11| 13| 12| 10| 08|
    # +---+---+---+---+---+---+---+
    # | x | 14| 16| 18| 17| 15| x |
    # +---+---+---+---+---+---+---+
    # | x | x | 19| 21| 20| x | x |
    # +---+---+---+---+---+---+---+
    # | x | x | 22|*24| 23| x | x |
    # +---+---+---+---+---+---+---+
    # 1 床
    #   u   v   w   h   x   y
    [[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 00
    [[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 01
    [[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 02
    [[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 03
    [[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 04
    [[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 05
    [[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 06

    [[808,407, 21, 23,  0,178],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 07
    [[829,407, 23, 23,619,178],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 08
    [[526,407,140, 42,  0,178],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 09
    [[666,407,142, 42,499,178],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 10
    [[162,407,182, 42, 77,178],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 11
    [[344,407,182, 42,379,178],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 12
    [[  0,407,162, 42,238,178],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 13

    [[725,333, 77, 54,  0,194],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 14
    [[803,333, 79, 53,561,194],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 15
    [[248,333,238, 74,  0,194],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 16
    [[486,333,240, 74,400,194],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 17
    [[  0,333,248, 74,195,194],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 18

    [[541,134,195,199,  0,229],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 19
    [[735,134,197,199,443,229],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 20
    [[  0,134,539,199, 49,229],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 21

    [[640,  0, 49,134,  0,346],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 22
    [[690,  0, 51,134,589,346],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 23
    [[  0,  0,640,134,  0,346],[ -1, -1, -1, -1, -1, -1],[ -1, -1, -1, -1, -1, -1]], # 24
    ]
    $map_dbw.log("@zahyo[0][0][0][0] = %d",@zahyo[0][0][0][0])
    # Bitmap読み込み
    @bitmaps = []
    for i in 1..5 # 0は意図的に空き
      @bitmaps[i] = RPG::Cache.load_bitmap("Graphics/Pictures/dungeon/", "dungeon0#{i}")
      printf("bitmap %d has loaded\n", i)
    end
    # スプライト初期化
    @spr_buff = []
    for i in 0...SPR_BUFF_SIZE
      @spr_buff[i] = Sprite.new
      @spr_buff[i].bitmap = nil
      @spr_buff[i].z = DISP_Z
      @spr_buff[i].visible = false
    end
    # 表示オブジェクトバッファ初期化
    @object_buff = []
    for i in 0...BUFF_SIZE
      @object_buff[i] = 0
    end
  end

  ##---------------------------------------------------------------------
  ## dispose 
  ##---------------------------------------------------------------------
  def dispose
    @spr_buff.each do |i|
      if i != nil
        if i.bitmap != nil
          i.bitmap.dispose
          i.dispose
        end
      end
    end
    @bitmaps.each do |i|
      if i != nil
        i.dispose
      end
    end
  end
  ##---------------------------------------------------------------------
  ## draw 
  ##---------------------------------------------------------------------
  def draw
    ##-------------- 初期化 --------------
    @spr_buff.each do |s|
      s.visible = false # 非表示
    end
    @object_buff.each do |o|
      o = 0 # そこには何も無い
    end
    ##-------------- マップから表示オブジェクトバッファに格納 --------------
    # ここではダミー
    @object_buff[0] = 4
    @object_buff[1] = 4
    @object_buff[2] = 4
    @object_buff[3] = 4
    @object_buff[4] = 4
    @object_buff[5] = 4
    @object_buff[6] = 4
    @object_buff[7] = 1
    @object_buff[8] = 1
    @object_buff[9] = 0
    @object_buff[10] = 1
    @object_buff[11] = 1
    @object_buff[12] = 1
    @object_buff[13] = 1
    @object_buff[14] = 1
    @object_buff[15] = 1
    @object_buff[16] = 1
    @object_buff[17] = 1
    @object_buff[18] = 1
    @object_buff[19] = 1
    @object_buff[20] = 1
    @object_buff[21] = 1
    @object_buff[22] = 1
    @object_buff[23] = 1
    ##-------------- スプライトを設定 --------------
    i = 0
    @object_buff.each do |o|
      if o != 0
        for j in 0..1 # 0は正面、1は側面
          z = 0 # 壁、扉
          if o < 4
            z = 1 # 床、浅水、深水
          end
          if @zahyo[z][i][j][0] != -1
            spr = @spr_buff[i * 3 + j]
            spr.bitmap = @bitmaps[o]
            spr.src_rect.set(@zahyo[z][i][j][0], @zahyo[z][i][j][1], @zahyo[z][i][j][2], @zahyo[z][i][j][3])
            spr.x = @zahyo[z][i][j][4]
            spr.y = @zahyo[z][i][j][5]
            spr.visible = true
          end
        end
      end
      i += 1
    end
  end
end

##---------------------------------------------------------------------
## dungeon_test 
##---------------------------------------------------------------------
def dungeon_test
  d = Dungeon.new
  d.draw
  loop do
    Graphics.update
    Input.update
    $map_dbw.update
    if Input::trigger?(Input::B)
      break
    end
  end
  d.dispose
  Graphics.update
  Input.update
end

##---------------------------------------------------------------------
## test03 
##---------------------------------------------------------------------
def test03
  t = Time.now
  $game_variables[106] = t
end

##---------------------------------------------------------------------
## test04 
##---------------------------------------------------------------------
def test04
  t0 = $game_variables[106]
  t1 = Time.now
  d = t1 - t0
  $game_variables[106] = 0
  print(d)
end



##---------------------------------------------------------------------
## test02
##---------------------------------------------------------------------
def test02
  sg = Status_Gamen.new
  loop do
    Graphics.update
    Input.update
    if !sg.update
      break
    end
  end
  sg.dispose
  T_Cache::clear
  GC.start
  Graphics.update
  Input.update
end


##---------------------------------------------------------------------
## test01
##---------------------------------------------------------------------
def test01
  battle_command_text = ["攻撃", "防御", "傷薬", "傷薬", "解毒剤", "精神安定剤", "万能薬"]
  bcw = Battle_Command_Window.new(0, 100, battle_command_text)
  loop do
    Graphics.update
    Input.update
    if !bcw.update
      break
    end
  end
  bcw.dispose
  Graphics.update
  Input.update
end

